#include <iostream>
#include "argparser.h"
#include "timer.h"

using namespace std;

int main( int argc, char *argv[] )
{
	unsigned int dimension = 3;
	unsigned int scramble_moves = 20;
	float turn_time = .33;

	ArgParser ap;

	ap.Optional( "t", &(turn_time) );
	ap.Optional( "d", &(dimension) );
	ap.Optional( "m", &(scramble_moves) );
	ap.Process( argc, argv );

	cerr << "turn_time: " << turn_time << endl;
	cerr << "dimension: " << dimension << endl;
	cerr << "scramble_moves: " << scramble_moves << endl;

	cerr << endl << endl << "Running timer for 10 seconds (twice)" << endl;

	Timer t;
	int last_time = 0;
	bool first_run = true;

	int counter = 0;

	t.Start();
	for (;;)
	{
		// it's not a good idea to query the timer too often on Windows --
		// throws everything out of whack (time slows down about 2x)
		// So we'll check it every 1000 times through this loop. Isn't this
		// ridiculous?
		if ( (counter++)%1000 == 0)
		{
			double current_time = t.Time();
	
			if ( (int) current_time != last_time )
			{
				cerr << (int) current_time << " seconds" << endl;
				last_time = (int) current_time;
			}
			if (last_time == 10)
			{
				if (first_run)
				{
					t.Reset();
					t.Start();
					first_run = false;
				}
				else
				{
					break;
				}
			}
		}
	}

	return 0;
}
